#include <iostream>
#include <deque>
#include <vector>
using namespace std;


class DS {
public:
    using VI = vector<int>;

    DS(int n) : n {n}, t {VI(n + 1)}
    {
        for (int i = 1; i <= n; ++i)
            t[i] = i;
    }

    int Find(int x)
    {
        if (x == t[x]) return x;
        return t[x] = Find(t[x]);
    }

    void Union(int x, int y)
    {
        t[y] = x;
    }
private:
    int n;
    VI t;
};

struct Edge {
    int a, b;
};

int n, m;

deque<Edge> edges;
deque<int> c;  //

void CitesteDate();
void Rezolva();

int main()
{
    CitesteDate();
    Rezolva();
}

void CitesteDate()
{
    cin >> n >> m;

    for (int i = 0, a, b; i < m; ++i)
    {
        cin >> a >> b;
        edges.push_front({a, b});
    }
}

void Rezolva()
{
    DS d(n);
    int k = n;
    for (auto [x, y] : edges) /// O(m)
    {
        c.push_front(k);

        int r1 = d.Find(x);
        int r2 = d.Find(y);
        if (r1 != r2)
        {
            k--;
            d.Union(r1, r2);
        }
    }

    for (const int& x : c)
        cout << x << '\n';
}


