#include <iostream>
#include <vector>
#include <stack>
using namespace std;

using VB  = vector<bool>;
using VI  = vector<int>;
using VVI = vector<VI>;

VVI G;
VB v;
VI L;  // L[x] - lung maxima a drumului care ajunge in x

stack<int> stk;
int n, m;

int Lmax;
void CitesteGraf();
void Dfs(int x);
void SortTopologica();
void Rezolva();

int main()
{
    CitesteGraf();
    Rezolva();
    cout << Lmax;
    return 0;
}

void Rezolva() /// O(m)
{
	SortTopologica();  // O(m)
	while (!stk.empty()) /// O(m)
    {
        int x = stk.top();
        stk.pop();

        for (int y : G[x])
        {
            L[y] = max(L[y], L[x] + 1);
            Lmax = max(Lmax, L[y]);
        }
    }
}

void SortTopologica()
{
    for (int x = 1; x <= n; ++x)
        if (!v[x])
            Dfs(x);
}
void Dfs(int x) // O(m)
{
    v[x] = true;

    for (int y : G[x])
        if (!v[y])
            Dfs(y);

    stk.push(x);
}

void CitesteGraf()
{
    cin >> n >> m;
    v = VB(n + 1);
    L = VI(n + 1);
    G = VVI(n + 1);
    int x, y;

    while (m--)
    {
        cin >> x >> y;
        G[x].push_back(y);
    }
}

