#include <fstream>
#include <vector>
#include <stack>
using namespace std;

ifstream fin("topsort.in");
ofstream fout("topsort.out");

using VB  = vector<bool>;
using VI  = vector<int>;
using VVI  = vector<VI>;

VVI G;
VB v;
int n, m;
stack<int> stk;

void CitesteGraf();
void SortareTopologica();
void Dfs(int x);

int main()
{
    CitesteGraf();
    SortareTopologica();
}

void SortareTopologica() /// O(n + m)
{
    for (int x = 1; x <= n; ++x) // O(m)
        if (!v[x])
            Dfs(x);

    while (!stk.empty())
    {
        fout << stk.top() << ' ';
        stk.pop();
    }
}

void Dfs(int x)
{
    v[x] = true;
    for (int y : G[x])
        if (!v[y])
            Dfs(y);

    stk.push(x);
}

void CitesteGraf()
{
    fin >> n >> m;
    G = VVI(n + 1);
    v = VB(n + 1);
    int x, y;
    while (m--)
    {
        fin >> x >> y;
        G[x].push_back(y);
    }
}


