#include <fstream>
#include <vector>
#include <cstring>
using namespace std;

ifstream fin("transport2.in");
ofstream fout("transport2.out");

vector<pair<int, int>> G[100010];

int N, M;
bool v[100010];

void Dfs(int x,const int lim);
bool Check(int g);
int BinSearch();
void ReadGraph();

int main()
{
    ReadGraph();
    fout << BinSearch();

    return 0;
}

void Dfs(int x,const int lim)
{
    v[x] = 1;
    for (auto [y, w] : G[x])
        if (!v[y] && w >= lim)
			Dfs(y, lim);
}

bool Check(int g)  // O(m + n)
{
    memset(v, 0 , sizeof(v));
    Dfs(1, g);
    return v[N];
}

int BinSearch()  // O(m * log2(W))
{
    int left = 1, right = 10000;
	int gr = 0;
    while (left <= right)
    {
        int mid = (left + right ) / 2;

        if (Check(mid))
        {
			gr = mid;
			left = mid + 1;
		}
        else
			right = mid - 1;
    }


    return gr;
}

void ReadGraph()
{
	fin >> N >> M;
    for (int x, y, w; M--;)
    {
        fin >> x >> y >> w;
        G[x].emplace_back(y, w);
        G[y].emplace_back(x, w);
    }
}
