#include <fstream>
#include <vector>
#include <queue>
using namespace std;

ifstream fin("transport2.in");
ofstream fout("transport2.out");

const int Inf = 0x3f3f3f3f;
using VP = vector<pair<int, int>>;

vector<VP> adj;
vector<int> g;       // g[x] = greutatea maxima a unui vehicul care poate ajunge in x
int n, m;

void Dijkstra(int x);
void CitesteGraf();

int main()
{
	CitesteGraf();
    Dijkstra(1);
    fout << g[n];
    fin.close();
    fout.close();
    return 0;
}

void Dijkstra(int x) // O(m * log n)
{
    priority_queue<pair<int, int>> Q; //max-heap
    g[x] = Inf;
    Q.push({Inf, x});
    while (!Q.empty())
    {
        auto [gr, x] = Q.top();
        Q.pop();
        if (gr < g[x] && g[x] != Inf)
            continue;
        for (auto [y, w]: adj[x])
            if (g[y] < min(g[x], w))
            {
                g[y] = min(g[x], w);
                Q.push({g[y], y});
            }
    }
}

void CitesteGraf()
{
	fin >> n >> m;
    adj = vector<VP>(n + 1);
    g = vector<int>(n + 1);

    for (int i = 1, x, y, w; i <= m; ++i)
    {
        fin >> x >> y >> w;
        adj[x].emplace_back(y, w);
        adj[y].emplace_back(x, w);
    }
}
