#include <fstream>
#include <vector>
#include <algorithm>
#include <tuple>
using namespace std;

ifstream fin("transport2.in");
ofstream fout("transport2.out");

int n, m;
int nod1, nod2, cost;
vector<tuple<int, int, int>> G;  // muchie ca tuplu: <w, x, y>
vector<int> t;

int Find(int x);
void Union(int x, int y);
void Solve();

int main()
{
    fin >> n >> m;
    t.resize(n + 1);
    for ( int i = 1; i <= n; ++i )
        t[i] = i;

    int x, y, w;
    for ( int i = 1; i <= m; ++i )
    {
        fin >> x >> y >> w;
        G.emplace_back(w, x, y);
    }


    // sortam muchiile descrescator dupa cost
    sort(G.begin(), G.end(), greater<tuple<int, int, int>>());
    // O(m * log m)

    Solve();

    return 0;
}

void Solve()
{
    int  r1, r2, x, y;
    for (auto tp : G)  // O(m)
    {
        x = get<1>(tp);
        y = get<2>(tp);

        r1 = Find(x);
        r2 = Find(y);
        if (r1 != r2)
            Union(r1, r2);
        if (Find(1) == Find(n))
        {
            fout << get<0>(tp);  // w
            return;
        }
    }
}

int Find(int x)
{
    if ( x == t[x] )
        return x;
    return x = Find(t[x]);
}

void Union(int r1, int r2)
{
   t[r1] = r2;
}
